import{S as qt,i as Rt,s as St,e as s,k as p,w as _e,t as r,M as xt,c,d as a,m as d,a as n,x as ue,h as o,b as h,G as t,g as l,y as ve,L as Dt,q as ge,o as ye,B as ke,v as It}from"../../chunks/vendor-hf-doc-builder.js";import{I as Ct}from"../../chunks/IconCopyLink-hf-doc-builder.js";import{C as Lt}from"../../chunks/CodeBlock-hf-doc-builder.js";function Nt(st){let g,Z,y,w,B,A,we,G,be,ee,L,Ee,te,b,$,je,q,Ae,$e,Pe,E,ze,R,Ce,Le,M,qe,ae,m,Re,S,Se,xe,x,De,Ie,F,Ne,Oe,H,Te,Ue,re,D,Be,oe,I,f,Ge,N,Me,Fe,W,He,We,Y,Ye,Je,J,Ke,Qe,se,O,Ve,ce,P,ne,k,j,K,z,Xe,Q,Ze,ie,_,et,V,tt,at,T,rt,ot,le,C,he;return A=new Ct({}),P=new Lt({props:{code:`from accelerate import Accelerator
import torch

accelerator = Accelerator(project_dir="my/save/path")

my_scheduler = torch.optim.lr_scheduler.StepLR(my_optimizer, step_size=1, gamma=0.99)
my_model, my_optimizer, my_training_dataloader = accelerator.prepare(my_model, my_optimizer, my_training_dataloader)

# Register the LR scheduler
accelerator.register_for_checkpointing(my_scheduler)

# Save the starting state
accelerator.save_state()

device = accelerator.device
my_model.to(device)

# Perform training
for epoch in range(num_epochs):
    for batch in my_training_dataloader:
        my_optimizer.zero_grad()
        inputs, targets = batch
        inputs = inputs.to(device)
        targets = targets.to(device)
        outputs = my_model(inputs)
        loss = my_loss_function(outputs, targets)
        accelerator.backward(loss)
        my_optimizer.step()
    my_scheduler.step()

# Restore previous state
accelerator.load_state("my/save/path/checkpointing/checkpoint_0")`,highlighted:`<span class="hljs-keyword">from</span> accelerate <span class="hljs-keyword">import</span> Accelerator
<span class="hljs-keyword">import</span> torch

accelerator = Accelerator(project_dir=<span class="hljs-string">&quot;my/save/path&quot;</span>)

my_scheduler = torch.optim.lr_scheduler.StepLR(my_optimizer, step_size=<span class="hljs-number">1</span>, gamma=<span class="hljs-number">0.99</span>)
my_model, my_optimizer, my_training_dataloader = accelerator.prepare(my_model, my_optimizer, my_training_dataloader)

<span class="hljs-comment"># Register the LR scheduler</span>
accelerator.register_for_checkpointing(my_scheduler)

<span class="hljs-comment"># Save the starting state</span>
accelerator.save_state()

device = accelerator.device
my_model.to(device)

<span class="hljs-comment"># Perform training</span>
<span class="hljs-keyword">for</span> epoch <span class="hljs-keyword">in</span> <span class="hljs-built_in">range</span>(num_epochs):
    <span class="hljs-keyword">for</span> batch <span class="hljs-keyword">in</span> my_training_dataloader:
        my_optimizer.zero_grad()
        inputs, targets = batch
        inputs = inputs.to(device)
        targets = targets.to(device)
        outputs = my_model(inputs)
        loss = my_loss_function(outputs, targets)
        accelerator.backward(loss)
        my_optimizer.step()
    my_scheduler.step()

<span class="hljs-comment"># Restore previous state</span>
accelerator.load_state(<span class="hljs-string">&quot;my/save/path/checkpointing/checkpoint_0&quot;</span>)`}}),z=new Ct({}),C=new Lt({props:{code:`from accelerate import Accelerator

accelerator = Accelerator(project_dir="my/save/path")

train_dataloader = accelerator.prepare(train_dataloader)
accelerator.load_state("my_state")

# Assume the checkpoint was saved 100 steps into the epoch
accelerator.skip_first_batches(train_dataloader, 100)`,highlighted:`<span class="hljs-keyword">from</span> accelerate <span class="hljs-keyword">import</span> Accelerator

accelerator = Accelerator(project_dir=<span class="hljs-string">&quot;my/save/path&quot;</span>)

train_dataloader = accelerator.prepare(train_dataloader)
accelerator.load_state(<span class="hljs-string">&quot;my_state&quot;</span>)

<span class="hljs-comment"># Assume the checkpoint was saved 100 steps into the epoch</span>
accelerator.skip_first_batches(train_dataloader, <span class="hljs-number">100</span>)`}}),{c(){g=s("meta"),Z=p(),y=s("h1"),w=s("a"),B=s("span"),_e(A.$$.fragment),we=p(),G=s("span"),be=r("Checkpointing"),ee=p(),L=s("p"),Ee=r(`When training a PyTorch model with \u{1F917} Accelerate, you may often want to save and continue a state of training. Doing so requires
saving and loading the model, optimizer, RNG generators, and the GradScaler. Inside \u{1F917} Accelerate are two convenience functions to achieve this quickly:`),te=p(),b=s("ul"),$=s("li"),je=r("Use "),q=s("a"),Ae=r("save_state()"),$e=r(" for saving everything mentioned above to a folder location"),Pe=p(),E=s("li"),ze=r("Use "),R=s("a"),Ce=r("load_state()"),Le=r(" for loading everything stored from an earlier "),M=s("code"),qe=r("save_state"),ae=p(),m=s("p"),Re=r("To further customize where and how states saved through "),S=s("a"),Se=r("save_state()"),xe=r(" the "),x=s("a"),De=r("ProjectConfiguration"),Ie=r(` class can be used. For example
if `),F=s("code"),Ne=r("automatic_checkpoint_naming"),Oe=r(" is enabled each saved checkpoint will be located then at "),H=s("code"),Te=r("Accelerator.project_dir/checkpoints/checkpoint_{checkpoint_number}"),Ue=r("."),re=p(),D=s("p"),Be=r("It should be noted that the expectation is that those states come from the same training script, they should not be from two separate scripts."),oe=p(),I=s("ul"),f=s("li"),Ge=r("By using "),N=s("a"),Me=r("register_for_checkpointing()"),Fe=r(`, you can register custom objects to be automatically stored or loaded from the two prior functions,
so long as the object has a `),W=s("code"),He=r("state_dict"),We=p(),Y=s("strong"),Ye=r("and"),Je=r(" a "),J=s("code"),Ke=r("load_state_dict"),Qe=r(" functionality. This could include objects such as a learning rate scheduler."),se=p(),O=s("p"),Ve=r("Below is a brief example using checkpointing to save and reload a state during training:"),ce=p(),_e(P.$$.fragment),ne=p(),k=s("h2"),j=s("a"),K=s("span"),_e(z.$$.fragment),Xe=p(),Q=s("span"),Ze=r("Restoring the state of the DataLoader"),ie=p(),_=s("p"),et=r("After resuming from a checkpoint, it may also be desireable to resume from a particular point in the active "),V=s("code"),tt=r("DataLoader"),at=r(` if
the state was saved during the middle of an epoch. You can use `),T=s("a"),rt=r("skip_first_batches()"),ot=r(" to do so."),le=p(),_e(C.$$.fragment),this.h()},l(e){const i=xt('[data-svelte="svelte-1phssyn"]',document.head);g=c(i,"META",{name:!0,content:!0}),i.forEach(a),Z=d(e),y=c(e,"H1",{class:!0});var pe=n(y);w=c(pe,"A",{id:!0,class:!0,href:!0});var ct=n(w);B=c(ct,"SPAN",{});var nt=n(B);ue(A.$$.fragment,nt),nt.forEach(a),ct.forEach(a),we=d(pe),G=c(pe,"SPAN",{});var it=n(G);be=o(it,"Checkpointing"),it.forEach(a),pe.forEach(a),ee=d(e),L=c(e,"P",{});var lt=n(L);Ee=o(lt,`When training a PyTorch model with \u{1F917} Accelerate, you may often want to save and continue a state of training. Doing so requires
saving and loading the model, optimizer, RNG generators, and the GradScaler. Inside \u{1F917} Accelerate are two convenience functions to achieve this quickly:`),lt.forEach(a),te=d(e),b=c(e,"UL",{});var de=n(b);$=c(de,"LI",{});var me=n($);je=o(me,"Use "),q=c(me,"A",{href:!0});var ht=n(q);Ae=o(ht,"save_state()"),ht.forEach(a),$e=o(me," for saving everything mentioned above to a folder location"),me.forEach(a),Pe=d(de),E=c(de,"LI",{});var X=n(E);ze=o(X,"Use "),R=c(X,"A",{href:!0});var pt=n(R);Ce=o(pt,"load_state()"),pt.forEach(a),Le=o(X," for loading everything stored from an earlier "),M=c(X,"CODE",{});var dt=n(M);qe=o(dt,"save_state"),dt.forEach(a),X.forEach(a),de.forEach(a),ae=d(e),m=c(e,"P",{});var u=n(m);Re=o(u,"To further customize where and how states saved through "),S=c(u,"A",{href:!0});var mt=n(S);Se=o(mt,"save_state()"),mt.forEach(a),xe=o(u," the "),x=c(u,"A",{href:!0});var ft=n(x);De=o(ft,"ProjectConfiguration"),ft.forEach(a),Ie=o(u,` class can be used. For example
if `),F=c(u,"CODE",{});var _t=n(F);Ne=o(_t,"automatic_checkpoint_naming"),_t.forEach(a),Oe=o(u," is enabled each saved checkpoint will be located then at "),H=c(u,"CODE",{});var ut=n(H);Te=o(ut,"Accelerator.project_dir/checkpoints/checkpoint_{checkpoint_number}"),ut.forEach(a),Ue=o(u,"."),u.forEach(a),re=d(e),D=c(e,"P",{});var vt=n(D);Be=o(vt,"It should be noted that the expectation is that those states come from the same training script, they should not be from two separate scripts."),vt.forEach(a),oe=d(e),I=c(e,"UL",{});var gt=n(I);f=c(gt,"LI",{});var v=n(f);Ge=o(v,"By using "),N=c(v,"A",{href:!0});var yt=n(N);Me=o(yt,"register_for_checkpointing()"),yt.forEach(a),Fe=o(v,`, you can register custom objects to be automatically stored or loaded from the two prior functions,
so long as the object has a `),W=c(v,"CODE",{});var kt=n(W);He=o(kt,"state_dict"),kt.forEach(a),We=d(v),Y=c(v,"STRONG",{});var wt=n(Y);Ye=o(wt,"and"),wt.forEach(a),Je=o(v," a "),J=c(v,"CODE",{});var bt=n(J);Ke=o(bt,"load_state_dict"),bt.forEach(a),Qe=o(v," functionality. This could include objects such as a learning rate scheduler."),v.forEach(a),gt.forEach(a),se=d(e),O=c(e,"P",{});var Et=n(O);Ve=o(Et,"Below is a brief example using checkpointing to save and reload a state during training:"),Et.forEach(a),ce=d(e),ue(P.$$.fragment,e),ne=d(e),k=c(e,"H2",{class:!0});var fe=n(k);j=c(fe,"A",{id:!0,class:!0,href:!0});var jt=n(j);K=c(jt,"SPAN",{});var At=n(K);ue(z.$$.fragment,At),At.forEach(a),jt.forEach(a),Xe=d(fe),Q=c(fe,"SPAN",{});var $t=n(Q);Ze=o($t,"Restoring the state of the DataLoader"),$t.forEach(a),fe.forEach(a),ie=d(e),_=c(e,"P",{});var U=n(_);et=o(U,"After resuming from a checkpoint, it may also be desireable to resume from a particular point in the active "),V=c(U,"CODE",{});var Pt=n(V);tt=o(Pt,"DataLoader"),Pt.forEach(a),at=o(U,` if
the state was saved during the middle of an epoch. You can use `),T=c(U,"A",{href:!0});var zt=n(T);rt=o(zt,"skip_first_batches()"),zt.forEach(a),ot=o(U," to do so."),U.forEach(a),le=d(e),ue(C.$$.fragment,e),this.h()},h(){h(g,"name","hf:doc:metadata"),h(g,"content",JSON.stringify(Ot)),h(w,"id","checkpointing"),h(w,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),h(w,"href","#checkpointing"),h(y,"class","relative group"),h(q,"href","/docs/accelerate/v0.17.1/en/package_reference/accelerator#accelerate.Accelerator.save_state"),h(R,"href","/docs/accelerate/v0.17.1/en/package_reference/accelerator#accelerate.Accelerator.load_state"),h(S,"href","/docs/accelerate/v0.17.1/en/package_reference/accelerator#accelerate.Accelerator.save_state"),h(x,"href","/docs/accelerate/v0.17.1/en/package_reference/utilities#accelerate.utils.ProjectConfiguration"),h(N,"href","/docs/accelerate/v0.17.1/en/package_reference/accelerator#accelerate.Accelerator.register_for_checkpointing"),h(j,"id","restoring-the-state-of-the-dataloader"),h(j,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),h(j,"href","#restoring-the-state-of-the-dataloader"),h(k,"class","relative group"),h(T,"href","/docs/accelerate/v0.17.1/en/package_reference/accelerator#accelerate.Accelerator.skip_first_batches")},m(e,i){t(document.head,g),l(e,Z,i),l(e,y,i),t(y,w),t(w,B),ve(A,B,null),t(y,we),t(y,G),t(G,be),l(e,ee,i),l(e,L,i),t(L,Ee),l(e,te,i),l(e,b,i),t(b,$),t($,je),t($,q),t(q,Ae),t($,$e),t(b,Pe),t(b,E),t(E,ze),t(E,R),t(R,Ce),t(E,Le),t(E,M),t(M,qe),l(e,ae,i),l(e,m,i),t(m,Re),t(m,S),t(S,Se),t(m,xe),t(m,x),t(x,De),t(m,Ie),t(m,F),t(F,Ne),t(m,Oe),t(m,H),t(H,Te),t(m,Ue),l(e,re,i),l(e,D,i),t(D,Be),l(e,oe,i),l(e,I,i),t(I,f),t(f,Ge),t(f,N),t(N,Me),t(f,Fe),t(f,W),t(W,He),t(f,We),t(f,Y),t(Y,Ye),t(f,Je),t(f,J),t(J,Ke),t(f,Qe),l(e,se,i),l(e,O,i),t(O,Ve),l(e,ce,i),ve(P,e,i),l(e,ne,i),l(e,k,i),t(k,j),t(j,K),ve(z,K,null),t(k,Xe),t(k,Q),t(Q,Ze),l(e,ie,i),l(e,_,i),t(_,et),t(_,V),t(V,tt),t(_,at),t(_,T),t(T,rt),t(_,ot),l(e,le,i),ve(C,e,i),he=!0},p:Dt,i(e){he||(ge(A.$$.fragment,e),ge(P.$$.fragment,e),ge(z.$$.fragment,e),ge(C.$$.fragment,e),he=!0)},o(e){ye(A.$$.fragment,e),ye(P.$$.fragment,e),ye(z.$$.fragment,e),ye(C.$$.fragment,e),he=!1},d(e){a(g),e&&a(Z),e&&a(y),ke(A),e&&a(ee),e&&a(L),e&&a(te),e&&a(b),e&&a(ae),e&&a(m),e&&a(re),e&&a(D),e&&a(oe),e&&a(I),e&&a(se),e&&a(O),e&&a(ce),ke(P,e),e&&a(ne),e&&a(k),ke(z),e&&a(ie),e&&a(_),e&&a(le),ke(C,e)}}}const Ot={local:"checkpointing",sections:[{local:"restoring-the-state-of-the-dataloader",title:"Restoring the state of the DataLoader "}],title:"Checkpointing"};function Tt(st){return It(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Mt extends qt{constructor(g){super();Rt(this,g,Tt,Nt,St,{})}}export{Mt as default,Ot as metadata};
